/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-react-core";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterPolygonSeries = /*@__PURE__*/ (() => {
    class ScatterPolygonSeries extends ShapeSeriesBase {
        bc() {
            return new ScatterPolygonSeries();
        }
        get_e4() {
            return true;
        }
        get_ez() {
            return true;
        }
        constructor() {
            super();
            this.w8 = null;
            this.w5 = new ScalerParams(1, ScatterPolygonSeries.ye, ScatterPolygonSeries.ye, false);
            this.w6 = new ScalerParams(1, ScatterPolygonSeries.ye, ScatterPolygonSeries.ye, false);
            this.xu = null;
            this.w0 = 1;
            this.ww = 1;
            this.ab = ScatterPolygonSeries.$;
        }
        vb() {
            return this.xa();
        }
        wd(a) {
            let b = a;
            b.cy(this.yg);
            b.cz(this.w9);
            super.wd(a);
            if (this.dm(a)) {
                return;
            }
            let c, d;
            let e = a.getViewInfo(c, d);
            c = e.p0;
            d = e.p1;
            let f = this.getEffectiveViewport1(a);
            this.w5 = new ScalerParams(1, d, c, this.uf.ch);
            this.w5.c = f;
            this.w6 = new ScalerParams(1, d, c, this.uh.ch);
            this.w6.c = f;
            if (c.width < 1 || c.height < 1) {
                return;
            }
            this.w8 = ((() => {
                let $ret = new ShapeAxisInfoCache();
                $ret.a = this.uf;
                $ret.b = this.uh;
                $ret.e = this.uf.ch;
                $ret.f = this.uh.ch;
                $ret.d = this.c7;
                $ret.c = this.uu;
                return $ret;
            })());
            if (this.xa()) {
                let g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
                b.dg.l(g, 400, d, c, this.hk);
                b.dg.j(g, false);
                if (this.u9()) {
                    this.xr(a);
                }
            }
        }
        xr(a) {
            a.dk = true;
            this.um.ay(this, this.u9(), runOn(this, this.t9));
            let b = this.um.d;
            let c = b != null;
            let d = this.getEffectiveViewport1(a);
            let e = this.c7 == null ? 0 : this.c7.count;
            a.dw((f) => {
                if (f._visibility == 0) {
                    let g = f.ak;
                    let h = f.content;
                    if (h == null) {
                        h = new DataContext();
                        f.content = h;
                    }
                    if (c) {
                        this.v8(g, e, a.q);
                    }
                    this.um.ac(f, h);
                }
            });
        }
        xa() {
            return this.xu != null && ((this.w4 != 1 && this.w4 != 0) || this.xv != null);
        }
        cd() {
            return new ScatterPolygonSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.w7 = a;
        }
        get_hasMarkers() {
            return true;
        }
        s1() {
            return this.ya;
        }
        s2() {
            return this.yb;
        }
        qx() {
            return this.xt;
        }
        ky() {
            return this.kz(this, this.xu);
        }
        ht() {
            return this.xc;
        }
        get w1() {
            return this.w0;
        }
        set w1(a) {
            this.w0 = a;
        }
        w3() {
            if (this.w2 == 0) {
                return 1;
            }
            return this.w2;
        }
        qj(a) {
            super.qj(a);
            this.w2 = a;
        }
        get wx() {
            return this.ww;
        }
        set wx(a) {
            this.ww = a;
        }
        wz() {
            if (this.wy == 0) {
                return 2;
            }
            return this.wy;
        }
        qi(a) {
            super.qi(a);
            this.wy = a;
        }
        qk(a) {
            super.qk(a);
            this.xc = a;
        }
        qf() {
            super.qf();
            if (this.index < 0) {
                return;
            }
            if (this.xv != null) {
                this.w7.dv();
                this.w7.ds();
            }
            else {
                let a = MarkerSeries.ud(this, this.w4);
                let b = MarkerSeries.ul(a);
                if (b == null) {
                    this.xt = MarkerSeries.uz;
                }
                else {
                    this.w7.dp(b);
                }
            }
            if (this.yc != null && this.w4 != 13) {
                this.p6("ActualMarkerBrush");
                let c = this.ya;
                this.w7.dt();
                this.w7.dq();
                let d = this.ya;
                let e = this.ev("ActualMarkerBrush", this.g2.f > 0 ? this.g2.d() : null, c, d);
                this.p8("ActualMarkerBrush", e);
            }
            else {
                if (this.w4 == 13) {
                    this.ya = this.cg.bt();
                }
                else {
                    if (this.wx != 2) {
                        if (this.cv != null) {
                            let f = this.cv.s2(this.index);
                            if (!isNaN_(this.hj) && this.hj != 1) {
                                f = BrushUtil.q(f, this.hj);
                            }
                            this.ya = f;
                        }
                        else {
                            this.ya = null;
                        }
                    }
                }
            }
            if (this.yd != null) {
                this.w7.du();
                this.w7.dr();
            }
            else {
                if (this.w4 == 13) {
                    this.yb = this.cg.bt();
                }
                else {
                    if (this.w2 == 2) {
                        this.yb = this.ya;
                    }
                    else {
                        this.yb = this.cv == null ? null : this.cv.s3(this.index);
                    }
                }
            }
            if (this.wx == 2 && this.yc == null && this.w4 != 13) {
                if (this.yb != null) {
                    let g = this.yb;
                    if (!isNaN_(this.hj) && this.hj != 1) {
                        g = BrushUtil.q(g, this.hj);
                    }
                    this.ya = g;
                }
                else {
                    this.ya = null;
                }
            }
        }
        ot() {
            super.ot();
            this.w1 = this.w3();
            this.wx = this.wz();
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case ScatterPolygonSeries.$$p[3]:
                case ScatterPolygonSeries.$$p[11]:
                case ScatterPolygonSeries.$$p[7]:
                case ScatterPolygonSeries.$$p[9]:
                case ScatterPolygonSeries.$$p[10]:
                    this.pg(b);
                    this.o4();
                    break;
                case ScatterPolygonSeries.$$p[6]:
                    this.w1 = this.w3();
                    this.pg(null);
                    this.o4();
                    break;
                case ScatterPolygonSeries.$$p[5]:
                    this.wx = this.wz();
                    this.pg(null);
                    this.o4();
                    break;
                case ScatterPolygonSeries.$$p[2]:
                    this.xu = d;
                    if (c == MarkerSeries.uz || d == MarkerSeries.uz || (c == null || d != null)) {
                        this.w7.dx();
                        this.pr(false);
                    }
                    this.cg.bl();
                    if (this.toolTip != null && this.ew) {
                        this.a3.a$aj(this, this.toolTip);
                    }
                    this.pr(false);
                    this.om();
                    break;
                case ScatterPolygonSeries.$$p[12]:
                    this.w7.cy(this.yg);
                    this.pr(false);
                    this.om();
                    break;
                case ScatterPolygonSeries.$$p[13]:
                    this.w7.cz(this.w9);
                    this.pr(false);
                    this.om();
                    break;
                case ScatterPolygonSeries.$$p[4]:
                    this.pr(false);
                    this.om();
                    break;
                case ScatterPolygonSeries.$$p[0]:
                case ScatterPolygonSeries.$$p[1]:
                    if (this.xa()) {
                        this.pr(false);
                    }
                    break;
            }
        }
        au(a, b) {
            let c = this.w7.b4(a);
            let d = null;
            if (c != null) {
                d = c.content;
            }
            if (d != null) {
                return d;
            }
            return super.au(a, b);
        }
        xs(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        dt(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.uf;
            let f = new ScalerParams(1, this.cv.tr, this.ty, e.ch);
            f.c = this.getEffectiveViewport1(this.cg);
            let g = this.uh;
            let h = new ScalerParams(1, this.cv.tr, this.ty, g.ch);
            h.c = this.getEffectiveViewport1(this.cg);
            a.clear();
            this.w7.dw((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.ty.left || k > this.ty.right || l < this.ty.top || l > this.ty.bottom) {
                        return;
                    }
                    j.b = e.em(k, f);
                    j.c = g.em(l, h);
                    j.a = i.content;
                    a.add(j);
                }
            });
            return true;
        }
        wu(a, b, c, d, e) {
            if (c == null || c.length != this.w8.d.count) {
                c = new Array(this.w8.d.count);
                for (let f = 0; f < this.w8.d.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = ((() => {
                let $ret = new ScalerParams(1, d, e, this.uf.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let h = ((() => {
                let $ret = new ScalerParams(1, d, e, this.uh.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = this.tq(a);
            let j = this.w8.a.em(i.left, g);
            let k = this.w8.a.em(i.right, g);
            let l = this.w8.b.em(i.bottom, h);
            let m = this.w8.b.em(i.top, h);
            if (this.w8.e) {
                let n = j;
                j = k;
                k = n;
            }
            if (this.w8.f) {
                let o = l;
                l = m;
                m = o;
            }
            let p = this.w8;
            let q = p.a;
            let r = p.b;
            let s;
            let t;
            let u = g.d.left;
            let v = g.d.right;
            let w = h.d.top;
            let x = h.d.bottom;
            for (let y = 0; y < this.w8.d.count; y++) {
                s = 0;
                t = 0;
                let z = null;
                let aa = a.cc.tryGetValue(y, z);
                z = aa.p1;
                if (z == null) {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
                else {
                    let ab = z.c;
                    let ac = RectUtil.l(ab);
                    s = ac.x;
                    t = ac.y;
                    if (s >= u && s <= v && t >= w && t <= x) {
                        c[y].x = s;
                        c[y].y = t;
                    }
                    else {
                        c[y].x = NaN;
                        c[y].y = NaN;
                    }
                }
            }
            return c;
        }
        xb(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.c7;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
                c++;
            }
            return b;
        }
    }
    ScatterPolygonSeries.$t = /*@__PURE__*/ markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.ye = /*@__PURE__*/ new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:ya:xw', [Brush.$], 'ActualMarkerOutline:yb:xx', [Brush.$], 'ActualMarkerTemplate:xt:xy', [DataTemplate.$, null], 'MarkerBrush:yc:xz', [Brush.$], 'MarkerCollisionAvoidance:wv:x0', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:wy:x1', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:w2:x2', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:yd:x3', [Brush.$], 'MarkerStyle:yf:x4', [Style.$], 'MarkerTemplate:xv:x5', [DataTemplate.$, null], 'MarkerThickness:xc:x6', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:w4:x7', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:yg:x8', [Style.$, null], 'ShapeStyleSelector:w9:x9', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
})();
/**
 * @hidden
 */
export let ScatterPolygonSeriesView = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.dk = false;
            this.db = null;
            this.dm = null;
            this.dh = null;
            this.df = null;
            this.dj = false;
            this.di = null;
            this.dn = null;
            this.dc = new Marker();
            this.d4 = null;
            this.dc = new Marker();
            this.dc.content = new DataContext();
            this.dh = a;
            this.di = new HashPool$2(Base.$, Marker.$);
            this.dn = new List$1(Marker.$, 0);
            this.dy(this.di);
            this.df = new NumericMarkerManager(1, (b) => this.di.item(b), (b) => this.dh.w8.d.item(b), runOn(this, this.d2), runOn(this, this.da), runOn(this, this.dl), () => this.dh.wv);
            this.df.q = runOn(this, this.d5);
        }
        au() {
            super.au();
            if (!this.q) {
                this.dh.yd = Defaults.am;
                this.dh.iv = Defaults.z;
                this.dh.xc = Defaults.y;
                this.dh.w4 = Defaults.f;
                this.dh.wy = Defaults.b;
            }
        }
        get dg() {
            return this.df;
        }
        d2(a) {
            this.dh.xs(a, this.di);
        }
        da() {
            this.db = this.dh.wu(this, this.di, this.db, this.by, this.bx);
            return this.db;
        }
        dl() {
            this.dm = this.dh.xb(this.di, this.dm);
            return this.dm;
        }
        c5(a, b) {
            return this.c6(a, b, true);
        }
        cm(a, b, c) {
            super.cm(a, b, c);
            ShapeSeriesViewBase.cl(this, a, b);
        }
        ck(a, b) {
            let c = a;
            if (c == null) {
                return;
            }
            c.an = b;
        }
        dw(a) {
            this.di.f(a);
        }
        dy(a) {
            a.create = runOn(this, this.de);
            a.destroy = runOn(this, this.d0);
            a.activate = runOn(this, this.dz);
            a.disactivate = runOn(this, this.d1);
        }
        de() {
            let a = new Marker();
            if (!this.dj) {
                a.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this.e;
                    return $ret;
                })());
            }
            a.ah = this.e.xt;
            this.dn.add(a);
            return a;
        }
        b4(a) {
            let b = this.dd(a, 0);
            if (b == null) {
                b = this.dd(a, 3);
            }
            return b;
        }
        dd(a, b) {
            let c;
            let d;
            let e;
            let f;
            for (let g = this.dn.count - 1; g >= 0; g--) {
                let h = this.dn._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        }
        d0(a) {
            a.content = null;
            this.dn.remove(a);
        }
        dz(a) {
            a._visibility = 0;
        }
        d1(a) {
            if (a.content != null) {
                (typeCast(DataContext.$, a.content)).item = null;
            }
            a._visibility = 1;
        }
        d3(a) {
            this.dj = a;
        }
        bj(a, b) {
            super.bj(a, b);
            if (!this.dk) {
                let c = a;
                let d = c.content;
                if (d != null) {
                    if (this.dh.ya != null) {
                        d.actualItemBrush = this.dh.ya;
                    }
                    else {
                        d.actualItemBrush = this.b6.su;
                    }
                    if (this.dh.ya != null) {
                        d.outline = this.dh.yb;
                    }
                    else {
                        d.outline = this.b6.sx;
                    }
                    d.thickness = this.dh.xc;
                }
            }
        }
        bk(a, b) {
            super.bk(a, b);
            let c = a;
            this.dc._visibility = c._visibility;
            this.dc.ah = c.ah;
            this.dc.width = c.width;
            this.dc.height = c.height;
            this.dc.m = c.m;
            this.dc.l = c.l;
            this.dc.n = c.n;
            this.dc.o = c.o;
            let d = this.bs(b);
            let e = this.dc.content;
            let f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.dh.xc + 3;
            }
        }
        a7(a, b) {
            super.a7(a, b);
            let c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.h();
            c.viewportTop = this.bx.top;
            c.viewportLeft = this.bx.left;
            c.viewportWidth = this.bx.width;
            c.viewportHeight = this.bx.height;
            c.passID = "Markers";
            let d = new DataTemplateRenderInfo();
            d.passInfo = c;
            d.isHitTestRender = b;
            let e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            let f = false;
            let g = a.h();
            e.context = g;
            d.context = g;
            let h = 0;
            let i = 0;
            if (this.dh.xt != null && this.dh.xt.passStarting != null) {
                this.dh.xt.passStarting(c);
            }
            for (let j = 0; j < this.dn.count; j++) {
                let k = this.dn._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bi(k, j, b);
                if (b) {
                    k = this.dc;
                }
                if (!f) {
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    let l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.q(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.dh.xt != null && this.dh.xt.passCompleted != null) {
                this.dh.xt.passCompleted(c);
            }
        }
        dv() {
            this.dh.xt = null;
        }
        ds() {
            this.dh.xt = null;
            this.dh.xt = this.dh.xv;
        }
        dt() {
            this.dh.ya = null;
        }
        dq() {
            this.dh.ya = null;
            if (!isNaN_(this.e.hj) && this.e.hj != 1) {
                let a = BrushUtil.q(this.dh.yc, this.e.hj);
                this.dh.ya = a;
            }
            else {
                this.dh.ya = this.dh.yc;
            }
        }
        du() {
            this.dh.yb = null;
        }
        dr() {
            this.dh.yb = null;
            this.dh.yb = this.dh.yd;
        }
        dp(a) {
            switch (a) {
                case "CircleMarkerTemplate":
                    this.dh.xt = this.dh.cv.p2;
                    break;
                case "TriangleMarkerTemplate":
                    this.dh.xt = this.dh.cv.qb;
                    break;
                case "PyramidMarkerTemplate":
                    this.dh.xt = this.dh.cv.p8;
                    break;
                case "SquareMarkerTemplate":
                    this.dh.xt = this.dh.cv.p9;
                    break;
                case "DiamondMarkerTemplate":
                    this.dh.xt = this.dh.cv.p3;
                    break;
                case "PentagonMarkerTemplate":
                    this.dh.xt = this.dh.cv.p6;
                    break;
                case "HexagonMarkerTemplate":
                    this.dh.xt = this.dh.cv.p4;
                    break;
                case "TetragramMarkerTemplate":
                    this.dh.xt = this.dh.cv.p6;
                    break;
                case "PentagramMarkerTemplate":
                    this.dh.xt = this.dh.cv.p7;
                    break;
                case "HexagramMarkerTemplate":
                    this.dh.xt = this.dh.cv.p5;
                    break;
            }
        }
        dx() {
            for (let a of fromEnum(this.dn)) {
                a.ah = this.dh.xt;
            }
            this.as();
        }
        d5(a) {
            if (this.d4 == null) {
                this.d4 = new DataTemplateMeasureInfo();
                this.d4.context = this.k.h();
            }
            this.d4.width = a.width;
            this.d4.height = a.height;
            this.d4.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.d4);
            }
            return new Size(1, this.d4.width, this.d4.height);
        }
        an(a) {
            let b = a;
            super.an(b);
            for (let c of fromEnum(this.di.c)) {
                let d = this.di.item(c);
                if (d._visibility != 1) {
                    let e = typeCast(ScatterPolygonSeries.$, this.e);
                    let f = this.e.a5.getMarkerVisualData(e, d, e.xt);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a3.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dh.title + "</span><br/>";
            a += "</div>";
            return a;
        }
    }
    ScatterPolygonSeriesView.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
})();
